export function uuid() {
  return Number(Math.random().toString().substr(2, 6) + Date.now()).toString(36)
}

export function debounce(delay, callback) {
  let task
  return function () {
    clearTimeout(task)
    task = setTimeout(() => {
      callback.apply(this, arguments)
    }, delay)
  }
}
